Unit AIT1R_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, UTAFSI_p;

procedure AIT1R(var A :Array of Real; M :Integer; N :Integer;
                LOW :Integer; var IERR :Integer); 
implementation

procedure AIT1R(var A :Array of Real; M :Integer; N :Integer;
                LOW :Integer; var IERR :Integer);
var
I,J,JJ,K,KB,KP1 :Integer;
T,X :Real;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190,_200,_210,_220,_230,_240,_250,_260,_270,_280;
begin
{ ********************************************************* }
{              .                }
{ ********************************************************* }

{        }
X := 0.0;
_10:

{         N }
if ( N >= 1 ) and ( M >= 1 ) 
 then goto _20;
IERR := 65;
UTAFSI('A','I','T','1','R',IERR);
goto _280;
_20:
IERR := 0;
for I:=1 to N do
 begin
  if ( A[(I-1)+(I-1)*M] <> 0.0 ) 
   then goto _30;
  IERR := -I;
  UTAFSI('A','I','T','1','R',IERR);
  goto _280;
_30:
_40:
 end;
if ( LOW <> 0 ) 
 then goto _160;

{       }
for K:=1 to N do
 begin
  A[(K-1)+(K-1)*M] := 1.0/A[(K-1)+(K-1)*M];
  T := -A[(K-1)+(K-1)*M];
  J := K - 1;
  I := (J Mod 5);
  if ( I = 0 ) 
   then goto _60;
  for JJ:=1 to I do
   begin
    A[(JJ-1)+(K-1)*M] := T*A[(JJ-1)+(K-1)*M];
_50:
   end;
_60:
  I := I + 1;
  if ( I > J ) 
   then goto _80;
  JJ := I;
  while ( JJ<=J ) do
   begin
    A[(JJ-1)+(K-1)*M] := T*A[(JJ-1)+(K-1)*M];
    A[(JJ+1-1)+(K-1)*M] := T*A[(JJ+1-1)+(K-1)*M];
    A[(JJ+2-1)+(K-1)*M] := T*A[(JJ+2-1)+(K-1)*M];
    A[(JJ+3-1)+(K-1)*M] := T*A[(JJ+3-1)+(K-1)*M];
    A[(JJ+4-1)+(K-1)*M] := T*A[(JJ+4-1)+(K-1)*M];
_70:
    inc(JJ,5);
   end;
_80:
  KP1 := K + 1;
  if ( N < KP1 ) 
   then goto _140;
  for J:=KP1 to N do
   begin
    T := A[(K-1)+(J-1)*M];
    A[(K-1)+(J-1)*M] := 0.0;
    I := (K Mod 4);
    if ( I = 0 ) 
     then goto _100;
    for JJ:=1 to I do
     begin
      A[(JJ-1)+(J-1)*M] := A[(JJ-1)+(J-1)*M] + T*A[(JJ-1)+(K-1)*M];
_90:
     end;
_100:
    I := I + 1;
    if ( I > K ) 
     then goto _120;
    JJ := I;
    while ( JJ<=K ) do
     begin
      A[(JJ-1)+(J-1)*M] := A[(JJ-1)+(J-1)*M] + T*A[(JJ-1)+(K-1)*M];
      A[(JJ+1-1)+(J-1)*M] := A[(JJ+1-1)+(J-1)*M] + T*A[(JJ+1-1)+(K-1)*M];
      A[(JJ+2-1)+(J-1)*M] := A[(JJ+2-1)+(J-1)*M] + T*A[(JJ+2-1)+(K-1)*M];
      A[(JJ+3-1)+(J-1)*M] := A[(JJ+3-1)+(J-1)*M] + T*A[(JJ+3-1)+(K-1)*M];
_110:
      inc(JJ,4);
     end;
_120:
_130:
   end;
_140:
_150:
 end;
goto _280;

{       }
_160:
for KB:=1 to N do
 begin
  K := N + 1 - KB;
  A[(K-1)+(K-1)*M] := 1.0/A[(K-1)+(K-1)*M];
  T := -A[(K-1)+(K-1)*M];
  KP1 := K + 1;
  J := N - K;
  I := (J Mod 5) + K;
  if ( I < KP1 ) 
   then goto _180;
  for JJ:=KP1 to I do
   begin
    A[(JJ-1)+(K-1)*M] := T*A[(JJ-1)+(K-1)*M];
_170:
   end;
_180:
  I := I + 1;
  if ( I > N ) 
   then goto _200;
  JJ := I;
  while ( JJ<=N ) do
   begin
    A[(JJ-1)+(K-1)*M] := T*A[(JJ-1)+(K-1)*M];
    A[(JJ+1-1)+(K-1)*M] := T*A[(JJ+1-1)+(K-1)*M];
    A[(JJ+2-1)+(K-1)*M] := T*A[(JJ+2-1)+(K-1)*M];
    A[(JJ+3-1)+(K-1)*M] := T*A[(JJ+3-1)+(K-1)*M];
    A[(JJ+4-1)+(K-1)*M] := T*A[(JJ+4-1)+(K-1)*M];
_190:
    inc(JJ,5);
   end;
_200:
  KP1 := K - 1;
  if ( KP1 < 1 ) 
   then goto _260;
  for J:=1 to KP1 do
   begin
    T := A[(K-1)+(J-1)*M];
    A[(K-1)+(J-1)*M] := 0.0;
    JJ := N - K + 1;
    I := (JJ Mod 4) + K - 1;
    if ( I < K ) 
     then goto _220;
    for JJ:=K to I do
     begin
      A[(JJ-1)+(J-1)*M] := A[(JJ-1)+(J-1)*M] + T*A[(JJ-1)+(K-1)*M];
_210:
     end;
_220:
    I := I + 1;
    if ( I > N ) 
     then goto _240;
    JJ := I;
    while ( JJ<=N ) do
     begin
      A[(JJ-1)+(J-1)*M] := A[(JJ-1)+(J-1)*M] + T*A[(JJ-1)+(K-1)*M];
      A[(JJ+1-1)+(J-1)*M] := A[(JJ+1-1)+(J-1)*M] + T*A[(JJ+1-1)+(K-1)*M];
      A[(JJ+2-1)+(J-1)*M] := A[(JJ+2-1)+(J-1)*M] + T*A[(JJ+2-1)+(K-1)*M];
      A[(JJ+3-1)+(J-1)*M] := A[(JJ+3-1)+(J-1)*M] + T*A[(JJ+3-1)+(K-1)*M];
_230:
      inc(JJ,4);
     end;
_240:
_250:
   end;
_260:
_270:
 end;
_280:
end;

end.
